
QGIS Application - Bug report #15803

2.18: Move Selection to Top not working in attribute table

2016-11-03 06:40 AM - Richard Duivenvoorde

Status: Closed

Priority: High

Assignee: Luigi Pirelli

Category: Attribute table

Affected QGIS version:2.18.4 Regression?: Yes

Operating System: Easy fix?: No

Pull Request or Patch supplied:Yes Resolution:

Crashes QGIS or corrupts data:No Copied to github as #: 23723

Description

In my current 2.18 the button 'Move Selection to top' (see attached screenshot) in the attributes table is not working.

in 2.14 on exact same machine + data it just works.

Associated revisions

Revision a82b8cfb - 2017-05-10 12:34 PM - Luigi Pirelli

[attributetable] fix sortOnTop due to sortOrder wrong enum values from QgsAttributeTableConfig: fixes #15803

Revision c092effc - 2017-05-10 01:02 PM - Luigi Pirelli

[attributetable] fix sortOnTop due to sortOrder wrong enum values from QgsAttributeTableConfig: fixes #15803

port to 3.0 for https://github.com/qgis/QGIS/pull/4306

Revision 8e60510e - 2017-05-11 10:46 AM - Alessandro Pasotti 

Merge pull request #4444 from boundlessgeo/sort_on_top_portTo3

[attributetable] Fix "Move selection to top" for 3.x regression fixes #15803

Revision 7ba28ec1 - 2017-05-11 10:47 AM - Alessandro Pasotti 

Merge pull request #4306 from boundlessgeo/sort_on_top

[attributetable] Fix "Move selection to top": for 2.18 regression fixes #15803

History

#1 - 2016-11-03 10:34 AM - Giovanni Manghi

- Priority changed from Normal to Severe/Regression

- Category set to Attribute table

#2 - 2016-11-03 10:36 AM - Giovanni Manghi

see also #15663
#3 - 2016-11-04 01:08 AM - Richard Duivenvoorde

Yep, confirmed here Paolo's trick: if you in the lower left corner of the attribute table temporarily use 'Show Selected Features' and then go back to 'Show

All Features' the button is working temporarily(!).

Closing and reopening the attribute table again and the problem is their again.

Looks like some signal is not coming through?

In debig info I see:

src/app/qgsmaptoolselectutils.cpp: 293: (getMatchingFeatures) [7873ms] Number of new selected features: 5

#4 - 2016-11-09 01:02 AM - Richard Duivenvoorde

Further investigating. It's getting stranger.

I have a new laptop, and so a fresh compiled QGIS, and I tested this there: no problem??

So thinking that it was something in the old laptop then, I started QGIS there with a new config, created a project and.. working.

Thinking it was a plugin, I removed all plugins from my profile.. but working with the created project :-(

WHICH made me think:

- it is the saved(!) PROJECT, and yes: if I open QGIS 2.18 (master seems to work), load the zipped shp attached in a non saved project, the sorting is NOT

working

- as soon as I save the projects, it IS working...

Can others test this out?

#5 - 2017-02-28 12:23 AM - Giovanni Manghi

- Affected QGIS version changed from 2.18.0 to 2.18.4

- Target version set to Version 2.18

#6 - 2017-02-28 04:24 AM - Giovanni Manghi

- Subject changed from 2.18: Move Selection to Top not working in attribute tabel to 2.18: Move Selection to Top not working in attribute table

see also #15370

#7 - 2017-03-23 10:19 AM - Luigi Pirelli

confirmed with latest build (5afdf6f) of 2.18 on the test data

#8 - 2017-03-24 01:28 AM - Luigi Pirelli

nor saving project change the behaviour

2025-04-27 2/4



#9 - 2017-03-27 02:00 AM - Luigi Pirelli

the issue affect also Master (qgis3 - 64d1848)

the reason is that the sortColum is for some reason initialised to something differet to -1 => it does not sort when selectedOnTop is activated.

the rough fix is doing sort to current orderColumn() that has 0 as first value.

Investigating why orderColumn is set and if it create some more regressions.

#10 - 2017-03-27 03:50 AM - Luigi Pirelli

this PR should fix https://github.com/qgis/QGIS/pull/4306 for 2.18

#11 - 2017-03-27 04:36 AM - Luigi Pirelli

confirmed issue in Master with current latest code b8cb196

#12 - 2017-04-30 05:08 PM - Giovanni Manghi

- Regression? set to Yes

#13 - 2017-04-30 05:08 PM - Giovanni Manghi

- Priority changed from Severe/Regression to High

#14 - 2017-05-01 01:10 AM - Giovanni Manghi

- Easy fix? set to No

#15 - 2017-05-05 06:05 PM - Alessandro Pasotti

- Description updated

- Pull Request or Patch supplied changed from No to Yes

#16 - 2017-05-06 09:31 AM - Alessandro Pasotti

- Assignee set to Luigi Pirelli

Patches:

Master: https://github.com/qgis/QGIS/pull/4444 but I cannot reproduce it

2.18: https://github.com/qgis/QGIS/pull/4306

#17 - 2017-05-06 12:00 PM - Giovanni Manghi

Alessandro Pasotti wrote:

Patches:

Master: https://github.com/qgis/QGIS/pull/4444 but I cannot reproduce it

2.18: https://github.com/qgis/QGIS/pull/4306

confirmed, on master seems ok (now?).

2025-04-27 3/4

https://github.com/qgis/QGIS/pull/4306
https://github.com/qgis/QGIS/pull/4444
https://github.com/qgis/QGIS/pull/4306
https://github.com/qgis/QGIS/pull/4444
https://github.com/qgis/QGIS/pull/4306


#18 - 2017-05-08 09:03 PM - Luigi Pirelli

discovered that the problem is still available on master if the layer has been loaded from a project with wrong setting values:

The proposed patche force the sortOrder value to be in the correct range value eg:

- Qt::AscendingOrder = 0

- QtDescendingOrder = 1

but the default value is loaded from the project in the tag:

<attributetableconfig ... sortOrder="<value>" >

that is loaded through code:

https://github.com/qgis/QGIS/blob/master/src/core/qgsattributetableconfig.cpp#L200

if for some reason (and seems many project can be affected) the value is not 0 or 1 => the sortOrder is skipped during sort => not applied

#19 - 2017-05-11 10:46 AM - Luigi Pirelli

- Status changed from Open to Closed

- % Done changed from 0 to 100

Applied in changeset commit:qgis|c092effc1c9f1add63b88ce36aa0deff19890496.

Files

0_0.zip 3.01 KB 2016-11-03 Richard Duivenvoorde

buttonselectiontotop.png 45.9 KB 2016-11-03 Richard Duivenvoorde
